;
;	      
;
.include "8515def.inc"		;     
							;     
							;  
.cseg 						; CODE segment
.org	0					; 
	rjmp 	init	 		;     ,
         		 			;  RESET    
.org	$0d					; 
.include "MyLib.inc"		;     
							;    
;******   ****************************************
;**    ,  RESET,   			**
;**  													**
;*************************************************************************
init:
	ldi 	temp, low(RAMEND) 	;   
	out 	SPL, temp		;    
	ldi 	temp, high(RAMEND)	;
	out 	SPH, temp		;

	rcall	Config_Port		;    
	rcall	Init_lcd		;    
;******   DDRAM  *******************
	rcall	wait_busy		; 
	ldi		zl,low(text0*2)	;   Z    text0		
	ldi		zh,high(text0*2); 
	ldi		temp2, 30	;     DDRAM	
ddram:	
	lpm				;   flash-  	
	mov 	dat_lcd, r0		; 
	rcall 	lcd_dat			;    DDRAM
	rcall 	wait_busy		; 
	ld 		r0, z+		;   1  Z  flash-
	dec 	temp2			;      
	brne 	ddram			;  
;*************************************************************************
;******   ***********************************************
main:
	ldi		temp, 2		;    
	rcall	lcd_dat			; DDRAM    
	ldi 	r24,5			;   
stop1:	
	rcall 	del200	
	dec 	r24
	brne 	stop
	ldi 	r24, 10			;   
shift:
	ldi 	dat_lcd,$18		;     
	rcall 	lcd_com
	rcall 	del200			;  ~1/5    4 
	dec 	r24
	brne 	shift
	ldi 	r24,5			;      
stop:	
	rcall 	del200	
	dec 	r24
	brne 	stop
	rjmp 	main			;  
;***********************************************************************
;******   **********************************************
init_lcd:
	ldi 	dat_lcd, 0b00001000	;  ,  
	rcall 	lcd_com			; 
	rcall 	del40			; 
	ldi 	dat_lcd, 0b00110000	; 8- , 1-, -58 
	rcall 	lcd_com			; 
	rcall 	del40			; 
	ldi 	dat_lcd, 0b00000110	;    ,
	rcall 	lcd_com			;      
	rcall 	del40			; 
	ldi 	dat_lcd, 0b00000001	;       
	rcall 	lcd_com			;  
	rcall 	del40			; 
	ret
;******     *******************************************
lcd_com:
	in		temp, ddrc	;     
	andi	temp, 0b11001111	;  RS  R/W ( PC4, PC5)
	out		ddrc, temp	; 
	sbi	 	portd, LCD_E	;   0  B( E=1).
	out 	porta, dat_lcd		;      LCD
	cbi 	portd, LCD_E		; C  0  B( E=0)
	ret
;******     ********************************************
lcd_dat:
	cbi		ddrc, LCD_RW	;  R/W
	sbi		ddrc, LCD_RS	;  RS
	sbi	 	portd, LCD_E	;   0  B( E=1). 
	out 	porta, dat_lcd		;  ASCII     LCD
	cbi 	portd, LCD_E		; C  0  B( E=0)
	ret
;******   BUSY      ***********
read_busy:
	clr		temp		;   A  
	out		ddra, temp	; 
	out		porta, temp	; 
	sbi		ddrc, LCD_RW	;  R/W
	cbi		ddrc, LCD_RS	;  RS
	sbi	 	portd, LCD_E	;   0  B ( E=1).
	nop				;   1 
	nop				; 
	nop				; 
	nop				; 
	in	 	dat_lcd, pina	;    
	cbi 	portd, LCD_E		; C  0  B ( E=0)
	ser		temp		;   A  
	out		ddra, temp	; 
	ret
;******    BUSY   ********************
wait_busy:				; 
	rcall	read_busy		; 
	sbrc	dat_lcd, busy		; 
	rjmp	wait_busy		; 
	ret
;******    ~40 **********************
del40:
	ldi		temp, 53
d3:	dec		temp
	brne	d3
	ret
;******    *****************************
del200:
	ldi		temp2, 5
d0:	ser		temp1
d1:	ldi		temp, 209
d2:	dec		temp
	brne	d2
	dec		temp1
	brne	d1
	dec		temp2
	brne	d0
	ret
;******  flash -       **
.org $200
text0:	.DB 168,112,184,188,101,112	;